program kurs;
uses CRT, GRAPH;
Const MaxX = 19; MaxY  = 21;
      Solid = 10;
      Space = 0;
      OneBreak = 1;
      Two = 2;
      Rad=5;
      len = 60;
      XMouse:Word = 250;
      Speed:byte = 10;
type PBall = ^Tball;
     Tball = object
               x,y:Real;
               dx,dy:Real;
               status:Boolean;
               link : PBall;
               constructor initball(xx,yy,dxx,dyy:Real);
               procedure  move;
               Procedure  Clear;
               Procedure  Put;
               Procedure  Draw;
               Destructor DoneBall;
             end;
    TField  = Array [1..MaxY,1..MaxX] of Byte;
Var Ball, Temp : PBall;
    i, j : Integer;
    Field : ^TField;
    Score, kol: Word;
    Level: byte;
constructor Tball.initball;
Begin
  x:=xx;
  y:=yy;
  dx:=dxx;
  dy:=dyy;
  Status:=True;
  link:=Nil;
end;

Destructor Tball.DoneBall;
var T: PBall;
Begin
  link^.Clear;
  T:=link^.link;
  Dispose(link);
  link:=T;
End;

Procedure Tball.move;
Begin
  x:=x+dx;
  y:=y+dy;
End;

Procedure Tball.Draw;
Begin
  Circle(Round(x),Round(y),Rad-1);
End;


Procedure Tball.put;
Begin
  SetColor(15);
  Draw;
End;

Procedure Tball.Clear;
Begin
  SetColor(7);
  Draw;
End;

Procedure WriteBall;
Var T : PBall;
Begin
 T:=Ball;
 Repeat
   T^.Clear;
   T^.Move;
   T^.Put;
   T:=T^.link
 Until T = Nil;
End;

Procedure InitGraphMode(A,I:Integer);
Begin
  InitGraph(A,i,'');
End;
Procedure DoneFirst;
Var T: PBall;
Begin
  T:=Ball;
  T^.Clear;
  Ball:=Ball^.link;
  Dispose(T);
End;

Procedure WriteCell(i,j:Byte);
Begin
  SetFillStyle(1,7);
  bar(j*30,i*20,j*30+29,i*20+19);
  if Field^[i,j]>Space then
  Begin
    SetColor(15);
    moveto(j*30+29,i*20);
    lineto(j*30,i*20);
    lineto(j*30,i*20+19);
    SetColor(8);
    lineto(j*30+29,i*20+19);
    lineto(j*30+29,i*20);
    case Field^[i,j] of
    Solid:
      Begin
        SetColor(15);
        line(j*30,i*20,j*30+29,i*20+19);
        line(j*30+29,i*20,j*30,i*20+19);
      end;
    Two: Begin
          SetFillStyle(1,1);
          bar(j*30+1,i*20+1,j*30+28,i*20+18);
         end;
     end;
 end;
End;

function sgn(r:Real):Integer;
Begin
  if r<0 then sgn:=-Rad else if r>0 then sgn:=Rad else sgn:=0;
End;

Procedure CheckBall;
Var T, T1 : PBall;
    i, j, i1, j1, dx, dy: Byte;
Begin
 T:=Ball;
 T1:=T;
 Repeat
   i:=Round(T^.y+sgn(T^.dy)) div 20;
   j:=Round(T^.x+sgn(T^.dx)) div 30;
   i1:=Round(T^.y-T^.dy) div 20;
   j1:=Round(T^.x-T^.dx) div 30;
   if Field^[i,j]>Space then
   Begin
   if (Field^[i,j1]=Space) and (Field^[i1,j]=Space) then
       begin
         t^.dy:=-T^.dy;
         t^.dx:=-T^.dx;
       end;
   if (i-i1<> 0) and (Field^[i,j1]>Space) then t^.dy:=-T^.dy;
   if (j-j1<> 0) and (Field^[i1,j]>Space) then t^.dx:=-T^.dx;
   if Field^[i,j]<Solid then
   begin
     Score:=Score+Field^[i,j]*10;
     Dec(kol);
     Dec(Field^[i,j]);
     WriteCell(i,j);
   end;
   end;
   if i=maxY Then
     if (t^.x+sgn(T^.dx)<Xmouse) or (t^.x+sgn(T^.dx)>Xmouse+len) then
     if T1<>T Then
     Begin
       T1^.DoneBall;
       T:=T1^.link;
     end
     Else
     Begin
       DoneFirst;
       T:=Ball;
       T1:=Ball;
     End Else
       begin
         t^.dy:=-T^.dy;
         T1:=T;
         T:=T^.link
       end
     Else
       Begin
         T1:=T;
         T:=T^.link
       End;
 Until T = Nil;

End;

Procedure InitField;
Var i,j:Integer;
Begin
  kol:=0;
  For i:=1 to MaxY do
    For j:=1 to maxX do
       if (i=1) or (j=1) or (j=maxX) then Field^[i,j]:=Solid
             Else Field^[i,j]:=Space;
  case level of
  1:
  For i:=2 to 7 do
    For j:=2 to maxX-1 do
       Begin
         Field^[i,j]:=(i+j) mod 2+1;
         kol:=kol+Field^[i,j];
       end;
   2:
  For i:=2 to 7 do
    For j:=2 to maxX-1 do
       Begin
         Field^[i,j]:=Two;
         kol:=kol+Field^[i,j];
       end;
   end;
  if level>2 then
  Begin
  For i:=4 to 8 do
    For j:=5 to maxX-1 do
       Begin
         Field^[i,j]:=Two;
         kol:=kol+Field^[i,j];
       end;
    For j:=4 to maxX-1 do
         Field^[9,j]:=Solid;
    For i:=4 to 8 do
         Field^[i,4]:=Solid;
   end;
End;

Procedure WriteField;
Var i,j:Integer;
Begin
  For i:=1 to MaxY do
    For j:=1 to maxX do
      writeCell(i,j);
End;

Procedure AddBall;
Var T, T1: PBall;
    k,i: byte;
begin
  k:=1;
  T:=Ball;
  T1:=T;
  While T^.link <> Nil do
    begin
      inc(k);
      T:=T^.link
    end;

  For i:=1 to k do
    begin
      new(T^.link);
      T:=T^.link;
      T^.initBall(T1^.x,T1^.y,-T1^.dx,T1^.dy);
      new(T^.link);
      T:=T^.link;
      T^.initBall(T1^.x,T1^.y,-T1^.dx,-T1^.dy);
      new(T^.link);
      T:=T^.link;
      T^.initBall(T1^.x,T1^.y,T1^.dx,-T1^.dy);
      T1:=T1^.link
    end;
end;

var key1:word;
    YesMouse:Boolean;
Procedure IsMouse;
var i:Boolean;
Begin
  i:=True;
  asm
    xor ax,ax
    int 33h
    cmp ax,0ffffh
    jz @@2
    mov i,0
@@2:
  end;
  YesMouse:=i;
end;
Procedure Cursor;
var x,key:Word;
    Yes:Boolean;
Begin
  x:=Xmouse;
  key:=0;
  Yes:=YesMouse;
  asm

    cmp Yes,1
    jz @@3
    mov ah,1
    int 16h
    jz @@EE
    xor ah,ah
    int 16h
    cmp al,'1'
    jne @@C
    sub x,10
    jmp @@EE
@@C:
    cmp al,'2'
    jne @@C1
    add x,10
    jmp @@EE
@@C1:
     cmp al,'0'
    jne @@EE
    mov key,1
    jmp @@EE
@@3:
    mov ax,03
    int 33h
    mov x,cx
    mov key,bx
@@EE:
  end;
  if (key and 1 = 1) and (key<>key1) then
  addball;
  key1:=key;
  if x<60 then x:=60;
  if x>maxx*30-1-len then x:=maxx*30-1-len;
  asm
    mov ax,03
    int 33h
    mov ax,4
    mov cx,x
    int 33h
  end;
  SetFillStyle(1,7);
  bar(60,MaxY*20,x,MaxY*20+20);
  bar(x+len,MaxY*20,maxx*30-1,MaxY*20+20);
  SetFillStyle(1,15);
  bar(x,MaxY*20,x+len,MaxY*20+20);
  Xmouse:=X;
End;
Var Life:Byte;
Procedure WriteLife;
Begin
  SetColor(15);
  outtextxy(60,7,'Life:');
  if yesmouse then
   outtextxy(60,450,'Mouse detected!') else
   outtextxy(60,450,'No mouse detected, use "1" and "2" for move!');
  for i:=1 to Life mod 4 do
    circle(100+i*15,10,Rad-1);
  SetColor(7);
  for i:=life+1 to 3 do
    circle(100+i*15,10,Rad-1);

End;
Procedure WriteScore;
var s:string;
Begin
  SetColor(15);
  SetFillStyle(1,7);
  Bar(200,7,480,18);
  str(Score,S);
  outtextxy(200,7,'Score: '+s);
  str(Level,S);
  outtextxy(380,7,'Level: '+s);
End;

Function Cont : Boolean;
Var c:Char;
Begin
  SetFillStyle(1,6);
  Bar(200,200,380,280);
  SetColor(15);
  Rectangle(200,200,380,280);
  outtextxy(220,220,'G A M E   O V E R');
  outtextxy(210,240,'Press Y for continue');

  c:=readkey;
  if c in ['y','Y','',''] then Cont:=False Else Cont:=True;
End;
Begin
  clrscr;
  Writeln('ARCANOID IS THE BEST GAME!');
  WriteLn;
  WriteLn('1..Easy game');
  WriteLn('2..Normal game');
  WriteLn('3..Hard game');
  WriteLn;
  Writeln('Your chose? ');
  ReadLn(i);
  case i of
   1: Speed:=20;
   3: Speed:=5;
  end;
  New(Field);
  IsMouse;
  InitGraphMode(VGA,VGAHI);
  new(Field);

  Repeat
  Level:=1;
  Score:= 0;
  Life:=3;
  SetFillStyle(1,7);
  Bar(0,0,639,479);
  InitField;
  WriteField;
  Repeat
  new(ball);
  Ball^.initball(245,maxY*20-Rad,0.7,-1);
  WriteLife;
  While (Ball <> Nil) and (kol<>0) do
    Begin
      Cursor;
      WriteBall;
      CheckBall;
      WriteScore;
      Delay(Speed);
    End;
  if kol=0 then
   begin
     while ball<>nil do DoneFirst;
     inc(level);
     SetFillStyle(1,7);
     Bar(0,0,639,479);
     InitField;
     WriteField;
   end else
  Dec(life);
  if life>0 then
  begin
    SetColor(1);
    outtextxy(60,460,'Press any key to continue!');
    ReadKey;
    SetFillStyle(1,7);
    Bar(60,460,500,470);
  end;
  Until (life=0);
  Until Cont;


  Dispose(Field);

  CloseGraph;
end.
